## dpkg 1.21.8

=== debian/changelog ===
dpkg (1.21.8) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-statoverride: Add support for --force-not-root. Closes: #1009069
    Based on a patch by John Spencer <maillist-dpkg@barfooze.de>.
  * dpkg: Fix «De-configuring» message to allow configuration to use new
    version.
  * Perl modules:
    - Dpkg::Source::Archive: Prevent directory traversal for in-place extracts.
      Reported by Max Justicz <max@justi.cz>. Fixes CVE-2022-1664.
    - Dpkg::Substvars: Add support for optional substvars assigned with ?=.
  * Documentation:
    - man: Reference deb-substvar(5) from dpkg-source(1) and dpkg-shlibdeps(1).
    - man: Structure and clarify deb-substvars(5).
      Prompted by Niels Thykier <niels@thykier.net>.
  * Build system:
    - Unhook dist-cpan from make dist target.
  * Packaging:
    - Silence warning about merged-usr-via-aliased-dirs on Ubuntu.
    - Remove useless [] around tr sets.
  * Localization:
    - Update Dutch translations. Closes: #1010031, #1010032, #1010033
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Update Portuguese man pages translations. Closes: #1011095
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Wed, 25 May 2022 10:39:29 +0200

dpkg (1.21.7) unstable; urgency=medium

  - The “Social Contract §3: We will not hide problems”
    and “Persuasion through bullying and abuse” release. -

  [ Guillem Jover ]
  * dpkg-fsys-usrunmess: Handle /lib/modules itself also being untracked.
    Closes: #1008764
  * Documentation:
    - man: Fix typo. Thanks to Peter Krefting <peter@softwolves.pp.se>.
      See #1008706.
  * Packaging:
    - Silence warning about merged-usr-via-aliased-dirs on Debian.
  * Localization:
    - Fix gettext parameter reordering syntax for German translation.
      Closes: #1008671
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1008706

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Apr 2022 02:27:33 +0200

dpkg (1.21.6) unstable; urgency=medium

  - This also clears a bullying NMU. -

  [ Guillem Jover ]
  * Documentation:
    - man: Document untracked kernel module files handling in
      dpkg-fsys-usrunmess(8).

 -- Guillem Jover <guillem@debian.org>  Tue, 29 Mar 2022 11:56:58 +0200

dpkg (1.21.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-fsys-usrunmess: Explicitly set user/group and mode for created dirs.
    Closes: #1008478
  * dpkg-fsys-usrunmess: Set a known umask before starting. See #1008478.
  * dpkg-fsys-usrunmess: Special case untracked kernel module files.
    Closes: #1008316
  * Perl modules:
    - Dpkg::Control::Types: Use bit shifts instead of literals in enum.
    - Dpkg::Control::Fields: Fix field_register() to return nothing.
    - Dpkg::Control::Fields: Refactor manifest types into new
      ALL_FILE_MANIFEST.
    - Dpkg::Control::Fields: Fix POD to end sentences with a dot.
    - Dpkg::Control::Fields: Fix POD to add missing spaces and blank lines.
    - Dpkg::Control::Fields: Document and clarify return types and values in
      POD.
  * Code internals:
    - libdpkg: Rename f_revision() to f_obs_revision().
    - libdpkg: Warn when parsing obsolete Recommended/Optional/Class fields.
      Prompted by David Kalnischkies <donkult@debian.org>.
    - libdpkg: Add missing dependency type to obsolete dependency fields.
    - libdpkg: Update code comment for obsolete fields.
  * Test suite:
    - Add test cases for obsolete fields.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 29 Mar 2022 02:52:14 +0200

dpkg (1.21.4) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-shlibdeps: Require non-empty name and version in SONAME formats.
  * Perl modules:
    - Dpkg::Control::Fields: Remove duplicate *Built-Using from field order
      lists. Reported by David Kalnischkies <donkult@debian.org>.
  * Documentation:
    - man: Clarify uses cases for Static-Built-Using.
      Prompted by Shengjing Zhu <zhsj@debian.org>.
  * Test suite:
    - Use actual octal numbers for chmod() calls.
    - Do not use non-POSIX shell syntax for arithmetic expressions.
      Based on a patch by Sören Tempel <soeren@soeren-tempel.net>.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sat, 26 Mar 2022 13:38:44 +0100

dpkg (1.21.3) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

  [ Guillem Jover ]
  * dpkg-db-backup: Check for required commands before starting.
  * dpkg: Allow absolute pathnames for configurable external run-time tools.
    Based on a patch by Adrian Ho <the.gromgit@gmail.com>. Closes: #1007816
  * dpkg-fsys-usrunmess: Add options and prompt about regression prevention
    package. Prompted by Paul Wise <pabs@debian.org>.
  * dpkg-deb: Move duped control member check inside the detection conditional.
  * dpkg-deb: Fix movecontrol() to take a directory argument.
  * dselect: Remove non-multi-cd code from multi_cd method.
  * dselect: Rename multicd method to media.
  * dselect: Remove left overs for mount support from disk method.
  * dselect: Remove bogus quote escaping from method setup scripts.
  * dselect: Rename disk method to file.
  * scripts: Use backport-version-regex vendor hook instead of hardcoding the
    marker.
  * Perl modules:
    - Dpkg::Source::Package::V3::Git: Name bundle remote as bundle.
    - Dpkg::Source::Package::V3::Git: Set origin remote to Vcs-Git if present.
    - Dpkg::Path: Resolve /dev/null before comparing canonicalized pathnames.
    - Dpkg::Compression: Conditionally use the gzip --rsyncable option.


## dpkg 1.21.9ubuntu1

=== debian/changelog ===
dpkg (1.21.9ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - Add Zstd compression and decompression support for binary packages.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
      from
      https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.
      See https://wiki.ubuntu.com/ToolChain/LTO for more information.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - Don't install dpkg-fsys-usrunmess script.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Jul 2022 00:00:34 +0200

dpkg (1.21.9) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Add support for --threads-max and DPKG_DEB_THREADS_MAX.
    Prompted by vv221 on IRC.
  * Perl modules:
    - Dpkg::Source::Package::V2: Always fix the permissions for upstream
      tarballs. Closes: #1012195
    - Dpkg::BuildFlags: Document optimize feature area.
  * Documentation:
    - man: Clarify that statoverrides do not need to be known to dpkg.
      Closes: #1011510
    - man: Expand Protected and Essential field use cases. Closes: #1008780
    - doc: Rename frontend.txt to frontend-api.txt.
    - doc: Move specifications under doc/spec.
    - man: Add references to rootless-builds.txt spec.
  * Code internals:
    - libdpkg: Refactor command actions for compression.
  * Build system:
    - Split the test-runner into its own script.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Jul 2022 11:25:58 +0200

dpkg (1.21.8ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - Add Zstd compression and decompression support for binary packages.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
      from
      https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.
      See https://wiki.ubuntu.com/ToolChain/LTO for more information.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - Don't install dpkg-fsys-usrunmess script.



=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
# Needed for ITS support.
 gettext (>= 0.19.7),
# Needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 zlib1g-dev,
 zstd,
 libbz2-dev,
 libzstd-dev,
 liblzma-dev,
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
# Needed for the functional test.
 bzip2 <!nocheck>,
 xz-utils <!nocheck>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 zlib1g-dev,
 libzstd-dev,
 liblzma-dev,
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
 xz-utils,
# Needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg,
 gpgv,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
 xz-utils,
Suggests:
 debian-keyring,
 gnupg,
 gpgv,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::Build::Info: build information functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITEFLAGS += --verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  TESTSUITEFLAGS += -j$(NUMJOBS)
endif

testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--sbindir=/sbin \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--without-libmd \
		--with-libz \
		--with-libzstd \
		--with-liblzma \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog*

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_builddeb:
	# Make debootstrap life easier on non-Debian based systems by
	# compressing dpkg.deb with xz instead of zstd.
	dh_builddeb -pdpkg -- -Zxz
	dh_builddeb -a -Ndpkg
	dh_builddeb

## dpkg 1.21.9+rpi1

=== tests/t-multiarch/Makefile ===
# Copyright © 2011 Linaro Limited
# Copyright © 2011 Raphaël Hertzog <hertzog@debian.org>
# Copyright © 2011-2012 Guillem Jover <guillem@debian.org>

TESTS_DEB :=

include ../Test.mk

NATIVE_ARCH := $(shell dpkg --print-architecture)
ifeq ($(NATIVE_ARCH),i386)
	FOREIGN_ARCH := amd64
else
	FOREIGN_ARCH := i386
endif

ma-setup:
	$(DPKG) --add-architecture $(FOREIGN_ARCH)

## BUILDING THE TEST PACKAGES ##

# Params are (dirname, pkgname, ver, arch, ma, dep)
# Dirname and pkgname are auto-prefixed with "pkg-ma"
define build_pkg
PKG_TO_BUILD += pkg-ma-$(1).deb

pkg-ma-$(1):: pkg-template
	[ -e pkg-ma-$(1) ] || cp -a pkg-template pkg-ma-$(1)
	sed -i -e "s/Package: .*/Package: pkg-ma-$(2)/" \
	       -e "s/Version: .*/Version: $(3)/" \
	       -e "s/Architecture: .*/Architecture: $(4)/" \
	       -e "s/Multi-Arch: .*/Multi-Arch: $(5)/" \
	       -e "s/Depends:.*/Depends: $(6)/" \
	    pkg-ma-$(1)/DEBIAN/control
	mkdir -p pkg-ma-$(1)/m-a
	echo "In file pkg-ma-$(1)" > pkg-ma-$(1)/m-a/foo-$(1)
	touch pkg-ma-$(1)

pkg-ma-$(1).deb: pkg-ma-$(1)
	$(DPKG_BUILD_DEB) --nocheck pkg-ma-$(1) pkg-ma-$(1).deb

clean-hook::
	rm -rf pkg-ma-$(1)
	rm -f pkg-ma-$(1).deb
endef

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach ma,same foreign allowed no,\
    $(foreach version,1.0 2.0,\
      $(eval $(call build_pkg,$(ma)_$(version)_$(arch),$(ma),$(version),$(arch),$(ma),)))))

# Arch: all done separately because M-A: same can't be Arch: all
$(foreach ma,foreign allowed no,\
  $(eval $(call build_pkg,$(ma)_1.0_all,$(ma),1.0,all,$(ma),)))

$(eval $(call build_pkg,same_1.0_all,same,1.0,all,no,))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,self-conflict_1.0_$(arch),self-conflict,1.0,$(arch),same,))\
  $(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
    $(eval $(call build_pkg,dep-on-$(ma)_1.0_$(arch),dep-on-$(ma),1.0,$(arch),foreign,pkg-ma-$(subst -,:,$(ma)) (>= 1.0)))))

$(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
  $(eval $(call build_pkg,dep-on-$(ma)_1.0_all,dep-on-$(ma),1.0,all,no,pkg-ma-$(subst -,:,$(ma)) (>= 1.0))))

shared_file_types := file symlink fifo
ifdef DPKG_AS_ROOT
shared_file_types += chardev blockdev
endif
$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach version,1.0 2.0,\
    $(eval $(call build_pkg,shared-conffiles_$(version)_orig_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(eval $(call build_pkg,shared-conffiles_$(version)_alt_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(foreach variant,orig alt,\
      $(foreach type,$(shared_file_types),\
        $(eval $(call build_pkg,shared-files_$(version)_$(variant)-$(type)_$(arch),shared-files,$(version),$(arch),same,))))))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,triggers_1.0_$(arch),triggers,1.0,$(arch),same,))\
  $(eval $(call build_pkg,shared-diversion_1.0_$(arch),shared-diversion,1.0,$(arch),same,)))

$(eval $(call build_pkg,act-trig_1.0_all,act-trig,1.0,all,no,))
$(eval $(call build_pkg,diversion_1.0_all,diversion,1.0,all,no,))
$(eval $(call build_pkg,diverted_1.0_all,diverted,1.0,all,no,))
$(eval $(call build_pkg,db-layout_1.0_$(NATIVE_ARCH),db-layout,1.0,$(NATIVE_ARCH),no,))
$(eval $(call build_pkg,db-layout_2.0_$(NATIVE_ARCH),db-layout,2.0,$(NATIVE_ARCH),same,))

build-hook: $(PKG_TO_BUILD)

## TEST CASES BELOW ##

TEST_CASES += test-print-foreign-architecture
TEST_CASES += test-build-invalid
TEST_CASES += test-build-valid
TEST_CASES += test-install-native
TEST_CASES += test-install-foreign
TEST_CASES += test-coinstall-ma-same
TEST_CASES += test-crossgrade
TEST_CASES += test-deps
TEST_CASES += test-coinstall-shared-files
TEST_CASES += test-coinstall-shared-conffiles
TEST_CASES += test-coinstall-triggers
TEST_CASES += test-coinstall-diversions
TEST_CASES += test-dpkg-output
TEST_CASES += test-db-layout

test-case: $(TEST_CASES)

test-print-foreign-architecture:
	echo $(FOREIGN_ARCH) >ref-arch
	echo foobar >>ref-arch
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	$(DPKG) --remove-architecture foobar
	$(call stdout_is,$(DPKG) --print-foreign-architectures,)
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(call stdout_is,$(DPKG) --print-foreign-architectures,$(FOREIGN_ARCH))
	$(DPKG) --add-architecture foobar
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	# Ensure all/any can't be added as foreign arch
	! $(DPKG) --add-architecture all
	! $(DPKG) --add-architecture any
	# Ensure the native arch is never considered as
	$(DPKG) --add-architecture $(NATIVE_ARCH)
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	$(DPKG) --remove-architecture foobar
	rm -f ref-arch

test-build-invalid:
	# Test build of Architecture: all with Multi-Arch: same field
	! $(DPKG_BUILD_DEB) pkg-template foo.deb
	rm -f foo.deb

test-build-valid:
	# Test build of package with valid dependency (ma-allowed:fake)
	$(DPKG_BUILD_DEB) pkg-ma-dep-on-allowed-fake_1.0_$(NATIVE_ARCH) foo.deb
	rm -f foo.deb

test-install-native:
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign)
	$(call pkg_is_installed,pkg-ma-allowed)
	$(call pkg_is_installed,pkg-ma-no)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-foreign pkg-ma-allowed pkg-ma-no
	$(call pkg_is_not_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign)
	$(call pkg_is_not_installed,pkg-ma-allowed)
	$(call pkg_is_not_installed,pkg-ma-no)

test-install-foreign:
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	# Installation of foreign arch packages must fail by default
	! $(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Once architecture has been added it should succeed
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(FOREIGN_ARCH) pkg-ma-foreign:$(FOREIGN_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH) pkg-ma-no:$(FOREIGN_ARCH)
	$(call pkg_is_not_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))

test-coinstall-ma-same: ma-setup
	# Coinstall 2 Multi-Arch: same packages
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	# Upgrade one, the other must be unconfigured
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(NATIVE_ARCH).deb
	$(call pkg_status_is,pkg-ma-same:$(NATIVE_ARCH),install ok unpacked)
	$(call pkg_status_is,pkg-ma-same:$(FOREIGN_ARCH),install ok half-configured)
	# Configure one alone must fail
	! $(DPKG_CONFIGURE) pkg-ma-same:$(NATIVE_ARCH)
	! $(DPKG_CONFIGURE) pkg-ma-same:$(FOREIGN_ARCH)
	# Upgrade the other and it's now possible to configure them
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(FOREIGN_ARCH).deb
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-foreign-allowed

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-foreign-allowed: ma-setup
	# Ensure we can cross-grade Multi-Arch: foreign/allowed
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_PURGE) pkg-ma-foreign:$(NATIVE_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-same
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-same
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-same-all
TEST_CASES_CROSSGRADE += test-crossgrade-no

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-any-all-%: ma-setup
	# M-A: $* / Upgrade from arch: any-native -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_field_is,pkg-ma-$*,Architecture,all)
	$(DPKG_PURGE) pkg-ma-$*
	$(call pkg_is_not_installed,pkg-ma-$*)
	# M-A: $* / Upgrade from arch: any-foreign -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-all-any-%: ma-setup
	# M-A: $* / Upgrade from arch: all -> any-native
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_field_is,pkg-ma-$*,Architecture,$(NATIVE_ARCH))
	$(DPKG_PURGE) pkg-ma-$*:$(NATIVE_ARCH)
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	# M-A: $* / Upgrade from arch: all -> any-foreign
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-same-all: ma-setup
	# Several M-A: same installed, can't upgrade to single arch all
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-same_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-same:all)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

pkg-ma-no_1.0_$(NATIVE_ARCH) pkg-ma-no_1.0_$(FOREIGN_ARCH):: pkg-template
	echo "A conffile" > $@/m-a/conffile-$@
	echo "/m-a/conffile-$@" > $@/DEBIAN/conffiles

test-crossgrade-no: ma-setup
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(DPKG_REMOVE) pkg-ma-no:$(NATIVE_ARCH)
	$(call pkg_status_is,pkg-ma-no:$(NATIVE_ARCH),deinstall ok config-files)
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no,/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Verify the replaced package disappeared
	$(call pkg_is_not_installed,pkg-ma-no:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(FOREIGN_ARCH))
	# Ensure the conffile of the disappeared package is still tracked
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -f '$${Conffiles}' -W pkg-ma-no:$(FOREIGN_ARCH), /m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH) [a-f0-9]+ obsolete$$)
	$(DPKG_PURGE) pkg-ma-no:$(FOREIGN_ARCH)

TEST_CASES_DEPS :=
TEST_CASES_DEPS += test-deps-same

=== debian/changelog ===
dpkg (1.21.9+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )

 -- Raspbian forward porter <root@raspbian.org>  Mon, 04 Jul 2022 03:06:27 +0000

=== debian/control ===
--- 
+++ 
@@ -16,9 +16,7 @@
 # Needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
  zlib1g-dev,
- zstd,
  libbz2-dev,
- libzstd-dev,
  liblzma-dev,
  libselinux1-dev [linux-any],
  libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
@@ -58,7 +56,6 @@
 Depends:
  ${misc:Depends},
  zlib1g-dev,
- libzstd-dev,
  liblzma-dev,
  libbz2-dev,
 Description: Debian package management static library
@@ -85,7 +82,6 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,

=== debian/rules ===
--- 
+++ 
@@ -52,7 +52,6 @@
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--without-libmd \
 		--with-libz \
-		--with-libzstd \
 		--with-liblzma \
 		--with-libbz2 \
 		# EOL
@@ -81,10 +80,3 @@
 
 override_dh_bugfiles:
 	dh_bugfiles -A
-
-override_dh_builddeb:
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -a -Ndpkg
-	dh_builddeb

## dpkg 1.21.11

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
 Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -15,14 +15,38 @@
  gettext (>= 0.19.7),
 # Needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
+ libmd-dev,
  zlib1g-dev,
  libbz2-dev,
  liblzma-dev,
  libselinux1-dev [linux-any],
- libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
+ libncurses-dev (>= 6.1+20180210),
 # Needed for the functional test.
  bzip2 <!nocheck>,
  xz-utils <!nocheck>,
+# Needed for the author release process.
+ git <pkg.dpkg.author-release>,
+ ca-certificates <pkg.dpkg.author-release>,
+ libmodule-build-perl <pkg.dpkg.author-release>,
+# Needed for the test suite in author mode.
+ fakeroot <pkg.dpkg.author-testing>,
+ gnupg <pkg.dpkg.author-testing>,
+ cppcheck <pkg.dpkg.author-testing>,
+ shellcheck <pkg.dpkg.author-testing>,
+ aspell <pkg.dpkg.author-testing>,
+ aspell-en <pkg.dpkg.author-testing>,
+ codespell <pkg.dpkg.author-testing>,
+ i18nspector <pkg.dpkg.author-testing>,
+ libtest-minimumversion-perl <pkg.dpkg.author-testing>,
+ libtest-perl-critic-perl <pkg.dpkg.author-testing>,
+ libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
+ libtest-pod-perl <pkg.dpkg.author-testing>,
+ libtest-spelling-perl <pkg.dpkg.author-testing>,
+ libtest-strict-perl <pkg.dpkg.author-testing>,
+ libtest-synopsis-perl <pkg.dpkg.author-testing>,
+# Needed for code coverage reports.
+ lcov <pkg.dpkg.code-coverage>,
+ libdevel-cover-perl <pkg.dpkg.code-coverage>,
 
 Package: dpkg
 Architecture: any
@@ -86,8 +110,8 @@
  build-essential,
  gcc | c-compiler,
  fakeroot,
- gnupg,
- gpgv,
+ gnupg | sq | pgpainless-cli,
+ gpgv | sq | pgpainless-cli,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:
@@ -95,6 +119,11 @@
 Breaks:
 # Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
  debhelper (<< 10.10.1~),
+# Uses new sq features, w/o requiring a hard dependency on sq.
+ sq (<< 0.25.0~),
+# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
+ pgpainless-cli (<< 1.3.13~),
+ libsop-java-java (<< 4.0.7~),
 Description: Debian package development tools
  This package provides the development tools (including dpkg-source)
  required to unpack, build and upload Debian source packages.
@@ -121,8 +150,8 @@
  xz-utils,
 Suggests:
  debian-keyring,
- gnupg,
- gpgv,
+ gnupg | sq | pgpainless-cli,
+ gpgv | sq | pgpainless-cli,
  gcc | c-compiler,
  binutils,
  patch,
@@ -139,6 +168,11 @@
 # Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
 # versions prior to 1.19.0.
  dgit (<< 3.13~),
+# Uses new sq features, w/o requiring a hard dependency on sq.
+ sq (<< 0.25.0~),
+# Uses required SOP feautres, w/o requiring a hard dependency on pgpainless.
+ pgpainless-cli (<< 1.3.13~),
+ libsop-java-java (<< 4.0.7~),
 Description: Dpkg perl modules
  This package provides the perl modules used by the scripts
  in dpkg-dev. They cover a wide range of functionality. Among them
@@ -197,6 +231,7 @@
  ${shlibs:Depends},
  ${misc:Depends},
 Suggests:
+ libdpkg-perl,
  perl,
 Description: Debian package management front-end
  dselect is a high-level interface for managing the installation and

=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,6 @@
 		--sbindir=/sbin \
 		--libexecdir=\$${exec_prefix}/lib \
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
-		--without-libmd \
 		--with-libz \
 		--with-liblzma \
 		--with-libbz2 \
@@ -80,3 +79,6 @@
 
 override_dh_bugfiles:
 	dh_bugfiles -A
+
+override_dh_compress:
+	dh_compress -Xspec/

## dpkg 1.21.12

=== debian/changelog ===
dpkg (1.21.12) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-architecture: Properly compute required information to gather.
    Reported by Sören Tempel <soeren@soeren-tempel.net>.
  * Code internals:
    - dpkg-architecture: Rename information tracking constants and variables.
  * Packaging:
    - Set paths for configure in autopkgtests to match installed ones.
    - Add libmd-dev to libdpkg-dev Depends.
      Reported by Alexandre Detiste <alexandre.detiste@gmail.com>.

 -- Guillem Jover <guillem@debian.org>  Tue, 06 Dec 2022 04:27:57 +0100

dpkg (1.21.11) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genbuildinfo: Do not fail if there is no cross-comiler.
    Closes: #1025273
  * Documentation:
    - doc: Update Doxyfile after code reorganization.
    - doc: Update Doxygen configuration from version 1.9.4.
    - man: Remove B<> or replace with S< >.
  * Code internals:
    - libdpkg: Document str_end parameter for str_strip_quotes().
  * Packaging:
    - Add libmd-dev to the test-root and test-not-root autopkgtests.
    - Add source lintian-overrides.
    - Remove obsolete libncursesw5-dev alternative from Build-Depends.
    - Update copyright years.
  * Localization:
    - Unfuzzy translations after markup fixes.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sat, 03 Dec 2022 00:18:29 +0100

dpkg (1.21.10) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg: Avoid setgid(2) call if not needed.
    Thanks to Christian Göttsche <cgzones@googlemail.com>. Closes: #1014332
  * dpkg-architecture: Do not compute values that are not required.
  * dpkg-buildpackage: Fix swapped long options for -m/-e.
  * dpkg-buildpackage: Add --source-by and --changed-by aliases for -m/-e.
  * dpkg-deb: Add support for DPKG_DEB_COMPRESSOR_TYPE/LEVEL. Closes: #550475
  * dpkg-genbuildinfo: Refactor build-tainted-by gathering into a function.
  * dpkg-genbuildinfo: Add new can-execute-cross-built-programs tainted flag.
    Thanks to Johannes Schauer Marin Rodrigues <josch@mister-muffin.de>.
    Closes: #1011191
  * dpkg: Make -E also take into account the architecture.
    Thanks to Ian Jackson <ijackson@chiark.greenend.org.uk>. Closes: #1014476
  * dpkg-source: Fix confusing regex match for option arguments.
  * dpkg-buildpackage: Fix --jobs and --jobs-try parsing with no «=».
  * dpkg-buildpackage: Rename --jobs/--jobs-try argument in --help output.
  * dpkg-buildpackage: Add new --jobs-force option.
  * dpkg-buildpackage: Change -j, --jobs semantics to non-force mode.
    Closes: #905835
  * dpkg, dpkg-statoverride: Install SELinux log callback to filter messages.
    Thanks to Christian Göttsche <cgzones@googlemail.com>.
  * dselect: Clarify non-free section as optional not free software component.
    Closes: #30972
  * dselect: Require the Dpkg modules for the ftp access method.
  * dpkg-buildpackage: Remove blank line around signfile output lines.
  * dpkg-buildpackage: Add new --sign-keyid and alias --sign-key to it.
  * dpkg-buildpackage: Add --sign-keyfile and DEB_SIGN_KEYFILE support.
  * dpkg-buildpackage: Add --sign-backend to specify the OpenPGP backend.
  * dpkg-source: Translate source format specific --help option descriptions.
  * dpkg-shlibdeps: Cache soname check against shlibs files. Closes: #1022766
  * libdpkg, dpkg: Switch triggers database to use reproducible package names.
    Closes: #990712
  * update-alternatives: Switch point at which we increment alternative
    refcount.
  * dpkg: Fix setting admindir when root is set.
  * dpkg-split: Add support for --root and --admindir.
  * Architecture support:
    - Move i386 and ia64 in an alphabetical-ish order in the cputable.
    - Add support for loong64 CPU.
      Based on a patch by 张丹丹 <zhangdandan@loongson.cn>. Closes: #1023486
  * Perl modules:
    - Dpkg::Source::Package::V1: Remove redundant exit handler for erasedir().
    - Dpkg::Source::Package::V2: Update and clarify patch header metadata
      template.
    - Dpkg::Deps: Merge dependency string into a single line when parsing.
      Closes: #1019565
    - Dselect::Ftp: Switch to current mirror list for ftp method output.
    - Dpkg::Source::Package: Use File::Spec instead of ad-hoc concatenation.
    - Dpkg::Source::Package: Verify signatures before printing source files
      addition.
    - Dpkg::Source::Package: Print verifying signature for all source formats.
    - Dpkg::Vendor: Rename @tries variable to @names.
    - Dpkg::Vendor: Fix get_vendor_file() to return on first match.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Avoid duplicate file loading attempts.
    - Dpkg::Vendor: Prefer loading lowercase vendor file first as documented.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Prefer loading capitalized vendor modules.
    - Dpkg::Vendor: Use a normalized key to access the cached objects.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Fix vendor file loading for vendors with special
      characters.
    - Dpkg::Vendor: Fix module loading for vendors with special characters.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Dpkg::Vendor: Deprecate loading vendor files with no special character
      mapping.
    - Dpkg::Vendor: Deprecate loading vendor module names starting lower-cased.
      Reported by Niels Thykier <niels@thykier.net> (on IRC).
    - Test::Dpkg: Refactor test files search into _test_get_files function().
    - Dselect::Ftp: Declare %CONFIG with «our» instead of «my».
    - Dselect::Ftp: Conditionally load perl modules shipped in the perl
      package.
    - Test::Dpkg: Make test_get_temp_path() remove the path before creating it.
    - Dpkg::File: Add new file_dump() function.
    - Dpkg::File: Add new file_touch() function.
    - Dpkg::OpenPGP: Remove unused $exec_opts argument from _exec_openpgp().


=== debian/control ===
--- 
+++ 
@@ -79,6 +79,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
+ libmd-dev,
  zlib1g-dev,
  liblzma-dev,
  libbz2-dev,

## dpkg 1.21.13

=== debian/control ===
--- 
+++ 
@@ -10,15 +10,16 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- pkg-config,
-# Needed for ITS support.
+ pkgconf | pkg-config,
+# Version needed for ITS support.
  gettext (>= 0.19.7),
-# Needed for --porefs defaults, conditional addenda and mode=eof.
+# Version needed for --porefs defaults, conditional addenda and mode=eof.
  po4a (>= 0.59),
  libmd-dev,
  zlib1g-dev,
  libbz2-dev,
- liblzma-dev,
+# Version needed for multi-threaded compressor support.
+ liblzma-dev (>= 5.4.0),
  libselinux1-dev [linux-any],
  libncurses-dev (>= 6.1+20180210),
 # Needed for the functional test.
@@ -56,7 +57,7 @@
  ${shlibs:Depends},
 Depends:
  ${misc:Depends},
-# Needed for --clamp-mtime in dpkg-deb -b.
+# Version needed for --clamp-mtime in dpkg-deb -b.
  tar (>= 1.28-1),
 Suggests:
  apt,
@@ -81,7 +82,8 @@
  ${misc:Depends},
  libmd-dev,
  zlib1g-dev,
- liblzma-dev,
+# Version needed for multi-threaded compressor support.
+ liblzma-dev (>= 5.4.0),
  libbz2-dev,
 Description: Debian package management static library
  This package provides the header files and static library necessary to
@@ -99,11 +101,11 @@
  ${misc:Depends},
  ${perl:Depends},
  libdpkg-perl (= ${source:Version}),
-# Needed for --clamp-mtime.
+# Version needed for --clamp-mtime.
  tar (>= 1.28-1),
  bzip2,
  xz-utils,
-# Needed for git-style diff support.
+# Version needed for git-style diff support.
  patch (>= 2.7),
  make,
  binutils,
@@ -140,7 +142,7 @@
 Depends:
  ${misc:Depends},
  ${perl:Depends},
-# Needed for arch tuples.
+# Version needed for arch tuples.
  dpkg (>= 1.18.11),
 Recommends:
 # Used by Dpkg::File.
